# Update a Distribution

{% hint style="info" %}
**Prerequisite:** Only contract administrators, owners, and users with `accessAndManageCdn` privilege can create and manage CDN distributions via the API. You can also set user privileges in the DCD. For more information, see [<mark style="color:blue;">Set User Privileges</mark>](/cloud/network-services/cdn/dcd-how-tos/set-user-privileges-cdn-dcd.md).
{% endhint %}

To update an existing CDN distribution, perform a `PUT` request with the `distributionID` of the CDN. The CDN distribution for a given `distributionID` is updated with the provided distribution details.

{% hint style="info" %}
**Note:** If a CDN distribution for a given `distributionID` does not exist, a distribution is created instead.
{% endhint %}

## Endpoint

Use the following endpoint to create or update a CDN distribution: `https://cdn.de-fra.ionos.com/distributions/{distributionId}`.

## Request

{% hint style="info" %}
**Note:** The following request contains a sample `distributionId`. Replace them with the `distributionId` value whose information you want to update.
{% endhint %}

```bash
curl --location \
--request PUT 'https://cdn.de-fra.ionos.com/distributions/9ba15778-16c4-543c-8775-e52acf4853f5' \
--header 'Authorization: Bearer eyJ0eXAiOiJKV1QiLCJraWQiO' \
--header 'Content-Type: application/json' \
--data '{
  "id": "9ba15778-16c4-543c-8775-e52acf4853f5",
  "metadata": {},
  "properties": {
    "domain": "example.com",
    "certificateId": "5a029f4a-72e5-11ec-90d6-0242ac120003",
    "routingRules": [
      {
        "scheme": "http/https",
        "prefix": "/api",
        "upstream": {
          "host": "server.example.com",
          "caching": true,
          "waf": true,
          "geoRestrictions": {
            "blockList": [
              "CN",
              "RU"
            ]
          },
          "rateLimitClass": "R100",
          "sniMode": "distribution"
        }
      }
    ]
  }
}'
```

{% tabs %}
{% tab title="Path Parameters" %}
Below is the list of mandatory path parameter:

| **Path Parameter** | **Type** | **Description**                        | **Example**                            |
| ------------------ | -------- | -------------------------------------- | -------------------------------------- |
| `distributionId`   | string   | The ID (UUID) of the CDN distribution. | `9ba15778-16c4-543c-8775-e52acf4853f5` |
| {% endtab %}       |          |                                        |                                        |

{% tab title="Request Body Parameters" %}
Below is the list of mandatory body parameters:

| **Body Parameters** | **Type** | **Description**                                                                                                                                                                                                                                   | **Example**                            |
| ------------------- | -------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------- |
| `id`                | string   | The ID (UUID) of the CDN distribution.                                                                                                                                                                                                            | `9ba15778-16c4-543c-8775-e52acf4853f5` |
| `domain`            | string   | The domain name for the CDN distribution.                                                                                                                                                                                                         | `example.com`                          |
| `scheme`            | string   | Choose whether to allow `http`, `https`, or `http/https` protocol.                                                                                                                                                                                | `http/https`                           |
| `prefix`            | string   | A prefix to match the beginning segment of the URL path and apply routing rule.                                                                                                                                                                   | `/api`                                 |
| `host`              | string   | An upstream host name that handles requests if data not cached in the CDN edge server.                                                                                                                                                            | `server.example.com`                   |
| `caching`           | boolean  | If enabled, CDN caches the data from the upstream host.                                                                                                                                                                                           | `true`                                 |
| `waf`               | boolean  | If enabled, protects the upstream host.                                                                                                                                                                                                           | `true`                                 |
| `rateLimitClass`    | string   | Limits the number of incoming requests per IP.                                                                                                                                                                                                    | `R10`                                  |
| `sniMode`           | string   | This field sets the SNI mode for the outgoing connection to the upstream host. Use `distribution` if the certificate must match the CDN distribution domain. Alternatively, use `origin` to ensure the certificate matches the upstream hostname. | `distribution`                         |
| {% endtab %}        |          |                                                                                                                                                                                                                                                   |                                        |

{% tab title="Request Header Parameters" %}
To make authenticated requests to the API, the following fields are mandatory in the request header:

| **Header Parameters** | **Required** | **Type** | **Description**                                                                                                                                                                                                                                                                 |
| --------------------- | ------------ | -------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `Authorization`       | yes          | string   | The Bearer token enables requests to authenticate using a JSON Web Token (JWT). From the DCD, [<mark style="color:blue;">Generate authentication token</mark>](/cloud/set-up-ionos-cloud/management/identity-access-management/token-manager.md#generate-authentication-token). |
| `Content-Type`        | yes          | string   | Set this to `application/json`.                                                                                                                                                                                                                                                 |
| {% endtab %}          |              |          |                                                                                                                                                                                                                                                                                 |
| {% endtabs %}         |              |          |                                                                                                                                                                                                                                                                                 |

## Response

`PUT` returns **200 Successful operation** when it updates an existing distribution. If the `distributionId` does not exist, the API creates a new distribution and returns **201** instead.

Following is an example of a successfully updated CDN distribution.

```bash
{
  "id": "9ba15778-16c4-543c-8775-e52acf4853f5",
  "type": "distribution",
  "href": "/distributions/9ba15778-16c4-543c-8775-e52acf4853f5",
  "metadata": {
    "createdDate": "2020-12-10T13:37:50+01:00",
    "createdBy": "ionos:identity:::users/87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "createdByUserId": "87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "lastModifiedDate": "2020-12-11T13:37:50+01:00",
    "lastModifiedBy": "ionos:identity:::users/87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "lastModifiedByUserId": "87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "resourceURN": "ionos:<product>:<location>:<contract>:<resource-path>",
    "publicEndpointIpv4": "1.2.3.4",
    "publicEndpointIpv6": "2001:db8::ff00:42:8329",
    "state": "AVAILABLE",
    "message": "In progress."
  },
  "properties": {
    "domain": "example.com",
    "certificateId": "5a029f4a-72e5-11ec-90d6-0242ac120003",
    "routingRules": [
      {
        "scheme": "http/https",
        "prefix": "/api",
        "upstream": {
          "host": "server.example.com",
          "caching": true,
          "waf": true,
          "geoRestrictions": {
            "blockList": [
              "CN",
              "RU"
            ]
          },
          "rateLimitClass": "R100",
          "sniMode": "origin"
        }
      }
    ]
  }
}
```

{% hint style="success" %}
**Result:** A CDN distribution is successfully updated or created.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ionos.com/cloud/network-services/cdn/api-how-tos/update-distribution.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
